// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <map>
#include <memory>
#include <vector>

#include <aoc/Vertex.hpp>

class Graph
{
public:
    const std::map<std::string, std::shared_ptr<Vertex>>& getVertices() const;
    void addEdge(const std::string& vertexId1, const std::string& vertexId2);
private:
    std::map<std::string, std::shared_ptr<Vertex>> vertices_;
    std::shared_ptr<Vertex> findOrAddVertex(const std::string& vertexId);
};
